 \newcommand\@lettgrversion{1999/03/26 v1.0b }
 %% Metri letter class
 %% with options:
 %% - metri : letter with the METRI head and foot.
 %% - french: for a french letter
 %% - english: for a english letter

\NeedsTeXFormat{LaTeX2e}
\ProvidesClass{lettgr}[\@lettgrversion by G.Ritschard]
 %\typeout{lettgr class \@lettgrversion  (c) G.Ritschard}

 % Load the ifthen package
 \RequirePackage{ifthen}

 \newboolean{@frenchnames}
 \newboolean{@englishnames}
 \newboolean{@logo}
 \setboolean{@logo}{false}
 \newboolean{@metri}
 \setboolean{@metri}{false}
 \newboolean{@metrigr}
 \setboolean{@metrigr}{false}
 \newboolean{@grprive}
 \newboolean{@graphicx}
 \newboolean{@nographicx}
 \newboolean{@telemail}
 \setboolean{@telemail}{false}
 \newboolean{@fromlieu}
 \setboolean{@fromlieu}{false}
 \newcommand*\logo@@name{metri}
 \newcommand*\logo@name{}
  \newcommand*\perso@phonenumber{}
  \newcommand*\perso@email{}
  \newcommand*\perso@name{}

% Declare Options
% first appearance
\DeclareOption{french}{
  \setboolean{@frenchnames}{true}
  \setboolean{@englishnames}{false}
}
\DeclareOption{english}{
  \setboolean{@frenchnames}{false}
  \setboolean{@englishnames}{true}
}
\DeclareOption{logo}{
  \setboolean{@logo}{true}
  \setboolean{@metri}{false}
  \setboolean{@metrigr}{false}
  \setboolean{@grprive}{false}
  %\renewcommand*\logo@name{}
}
\DeclareOption{metri}{
  \setboolean{@logo}{false}
  \setboolean{@metri}{true}
  \setboolean{@metrigr}{false}
  \setboolean{@grprive}{false}
  \renewcommand*\logo@@name{metri}
}
\DeclareOption{metrigr}{
  \setboolean{@logo}{false}
  \setboolean{@metrigr}{true}
  \setboolean{@metri}{true}
  \setboolean{@grprive}{false}
  \renewcommand*\logo@@name{mtri_g}
} 
\DeclareOption{privegr}{
  \setboolean{@logo}{false}
  \setboolean{@metri}{false}
  \setboolean{@metrigr}{false}
  \setboolean{@grprive}{true}
}
\DeclareOption{standard}{
  \setboolean{@logo}{false}
  \setboolean{@metri}{false}
  \setboolean{@metrigr}{false}
  \setboolean{@grprive}{false}
}
\DeclareOption{telemail}{
  \setboolean{@logo}{false}
  \setboolean{@metri}{false}
  \setboolean{@metrigr}{false}
  \setboolean{@grprive}{false}
  \setboolean{@telemail}{true}
}
\DeclareOption{nographicx}{
  \setboolean{@nographicx}{true} 
}
 \DeclareOption*{\PassOptionsToClass{\CurrentOption}{letter}}

 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 \ExecuteOptions{french,standard}
 \ProcessOptions
 \LoadClass[a4paper]{letter}
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 % standard packages distributed with LaTeX2e
 \RequirePackage[T1]{fontenc}
 \RequirePackage[french,english]{babel}
 
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % Additional commands:
 % ====================

 % to define the logo path
 \newcommand\logo@path{}
 \newcommand{\logopath}[1]{\renewcommand\logo@path{#1}
    \ifthenelse{\boolean{@graphicx}}{\graphicspath{{#1}}}{}
    }
 % for specifying the from place to be used with the date
\newcommand\lieudate[1]{\setboolean{@fromlieu}{true}\renewcommand\fromlieudate{#1}}
\newcommand\fromlieudate{}

 % subject
\newcommand\subject@{}
\newcommand\subject[1]{\renewcommand\subject@{#1}}
\newcommand\Yref@{}
\newcommand\Yref[1]{\renewcommand\Yref@{#1}}
\newcommand\Ref@{}
\newcommand\Ref[1]{\renewcommand\Ref@{#1}}
\newcommand\Sref@{} 
\newcommand\Sref[1]{\renewcommand\Sref@{#1}}

 % overrides the automatic letter date	
\newcommand{\letterdate@}{}       
\newcommand{\letterdate}[1]{\renewcommand\letterdate@{\fromlieudate, #1}}

 % personal name to insert below the logo
\newcommand\personame[1]{\renewcommand\perso@name{#1}}
\newcommand\persophonenumber[1]{\renewcommand\perso@phonenumber{#1}}
\newcommand\persoemail[1]{\renewcommand\perso@email{#1}}
\newcommand\logoname[1]{\renewcommand\logo@name{#1}}

 % to use with a scanned signature (the argument could be
 % an \includegraphics{signature} with sinature.eps 
 % an eps file.
\newcommand\scannedsign[1]{\def\scansign{#1}}
\newcommand\scansign{\vspace{6\medskipamount}\ }

 % \telemail for use with the METRI letter paper
\newcommand{\telemail}[1]{\renewcommand\fromtelemail{#1}}  

\newcommand\tel\@tel%to make it accessible in an \address defined in a .tex file
\newcommand\@le{} 
\newcommand\subjectname{}
\newcommand\Yrefname{} 
\newcommand\Refname{}
\newcommand\Srefname{}

 \newboolean{@premat}
 \newlength\premat@space
 \newcommand\premat
    {\setlength{\premat@space}{5ex}%
     \setboolean{@premat}{false}%
     \ifthenelse{\equal\@empty\Yref@}{}{%
        \setboolean{@premat}{true}%
        \addtolength{\premat@space}{-2ex}}%
     \ifthenelse{\equal\@empty\Ref@}{}{%
        \addtolength{\premat@space}{-2ex}
        \setboolean{@premat}{true}}%
     \ifthenelse{\equal\@empty\Sref@}{}{%
        \addtolength{\premat@space}{-2ex}
        \setboolean{@premat}{true}}%
     \ifthenelse{\equal\@empty\subject@}{}{%
        \addtolength{\premat@space}{-3ex}}
     \vspace{\premat@space}%
     \ifthenelse{\equal\@empty\Yref@}{}{%
        \textbf{\Yrefname:}\ \Yref@ \\}%
     \ifthenelse{\equal\@empty\Ref@}{}{%
        \textbf{\Refname:}\ \Ref@ \\}%
     \ifthenelse{\equal\@empty\Sref@}{}{%
        \textbf{\Srefname:}\ \Sref@ \\}%
     \ifthenelse{\equal\@empty\subject@}{}{%
        \ifthenelse{\boolean{@premat}}{\vspace{2ex}}{}%
        \setboolean{@premat}{true}%
        \textbf{\subjectname:}\ \subject@ \\}%
     \ifthenelse{\boolean{@premat}}{\vspace{3ex}}{}
     }

 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %adapted from Eijkhout(1991) p.239
 %\newcommand\inputifexist[1]{\doifexist{#1}{\input #1}}
 %\newcommand\doifexist[2]{
 %    \newread\instream \openin\instream=#1
 %    \ifeof\instream \message{==> file #1 not found <==}
 %    \else \closein\instream #2
 %    \fi}

 \setboolean{@graphicx}{false}
 \IfFileExists{graphicx.sty}
{\RequirePackage{graphicx}\setboolean{@graphicx}{true}}{}
 \ifthenelse{\boolean{@nographicx}}{\setboolean{@graphicx}{false}}{}

 % for options metri and grprive load "graphicx" package
 % to deal with .eps pictures.

 \newcommand\@tel{\phonename:\space}
 \newcommand\@logo{}
 \newcommand\logo@tel{telb}
 
 % Defaults values
 \newcommand\phonename{Tl}

 \newcommand\metrilocation{\parbox{14.5cm}{\center\Fmetri
	     D\'epartement d'Econom\'etrie, 40, bd du Pont-d'Arve,
CH-1211 Gen\`eve 4
	     \\%[-.6ex]
	     \makebox[0pt]%
	     {\mbox{\@tel} %
	     (+4122)\ \if\@empty\perso@phonenumber\else\perso@phonenumber\ /\
\fi705 8229\ \ Fax:
	     (+4122) 705 8299%
	     \if\@empty\perso@email\else\ \ e-mail: \perso@email\fi%
	     \hspace*{0pt}}}\ignorespaces
	    }

\def\Fmetri{\sffamily\mdseries\fontshape{n}\fontsize{10}{8}\selectfont} 
\def\Fprive{\sffamily\mdseries\fontshape{n}\fontsize{10}{10}\selectfont} 

\newcommand\fromtelemail{}
\ifthenelse{\boolean{@telemail}}
    {\renewcommand\fromtelemail{\Fprive Gilbert Ritschard\\[.1ex]
	{\@tel} (+41 22) 705 8233\\[-.1ex]
	%e-mail:
	Gilbert.Ritschard@themes.unige.ch
	}}{}

 % reading custom configuration file
 \InputIfFileExists{lettgr.cfg}
 	{}
 	{\ClassWarningNoLine{lettgr}{No configuration file ==> lettgr.cfg  <==
found }}
 \ifthenelse{\boolean{@metri}}
    {\location\metrilocation\setboolean{@logo}{true}
     \logoname{\logo@@name}}
    {}
 \ifthenelse{\boolean{@graphicx}}{
    \IfFileExists{\logo@path\logo@name.eps}
        {\renewcommand\@logo{\includegraphics{\logo@path\logo@name}\space}}{}
    \IfFileExists{\logo@path\logo@tel.eps}
        {\renewcommand\@tel{\includegraphics{\logo@path\logo@tel}\space}}{}
    }{}

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 %customizing the \opening and \closing commands
 %==============================================


\renewcommand{\opening}[1]{\unskip% y%
 % Defining some language specific names
 \ifthenelse{\boolean{@frenchnames}}
    {\selectlanguage{french}\lccode`\'=`\'%
     \ifthenelse{\boolean{@fromlieu}}{}{\renewcommand\fromlieudate{Gen\`{e}ve}}%
     \renewcommand*\phonename{Tl}%
     \renewcommand*\subjectname{Concerne\hskip 2pt}%
     \renewcommand*\Yrefname{V/rf}%
     \renewcommand*\Refname{N/rf}%
     \renewcommand*\enclname{Annexes}%
     \renewcommand\@le{le\ }%
    }
    {\selectlanguage{english}\selectlanguage{american}\lccode`\'=0%
     \ifthenelse{\boolean{@fromlieu}}{}{\renewcommand\fromlieudate{Geneva}}%
     \renewcommand*\phonename{Phone}%
     \renewcommand*\subjectname{Subject}%
     \renewcommand*\Yrefname{Your ref}%
     \renewcommand*\Refname{Ref}%
     \renewcommand\@le{}%
    }%
 \letterwidth{\textwidth}%
 \ifthenelse{\equal{}{\letterdate@}}{\renewcommand\letterdate@{\fromlieudate, \@le\@date}}{}%
 \ifthenelse{\boolean{@logo}}% insert logo
    {%
     \raggedright%
      \parbox[t]{\longindentation}{\unskip%
 	    \raisebox{-7.3cm}[0in]{\makebox[0in][l]{\hspace*{-3cm}---}}
 	    \hspace*{1.2cm}\raisebox{63pt}[0in]
 	    {\makebox[0in][c]
 		    {\protect\parbox[t]{8.5cm}{\center\@logo\makebox[0cm]{}
 		     \ifthenelse{\boolean{@metrigr}}{}
 		     {\\\centerline{\hfill\Fmetri\perso@name\hfill}}%
             }}
         }%
        }\hspace*{-\longindentation}%{-1.2cm}
     %
     \thispagestyle{metrifirstpage}\hspace*{\longindentation}%
     \parbox[t]{\indentedwidth}{
	    \letterdate@ \\*[4ex]  
 	     \toname \ifx\@empty\toaddress\else\\ \toaddress\fi 
 	    }
     \par\vskip -1cm minus 10ex%
     \premat#1\par\nobreak%
    }%else home
    {\raggedright%
 	 \raisebox{-7.3cm}[0in]{\makebox[0in][l]{\hspace*{-3cm}---}}%
     \ifx\@empty\fromtelemail\else
     \parbox[t]{\longindentation}{%
	    \makebox[0cm]{}\vspace{3.4cm}\\*[-2ex]
	    \hspace*{1.75cm}\makebox[0in]
	    {\protect\parbox[t]{6cm}{\center\footnotesize\fromtelemail}}
        }\hspace{-\longindentation}\fi
     %
     \ifx\@empty\fromaddress\thispagestyle{firstpage}\ignorespaces
	    \hspace*{\longindentation}\else\thispagestyle{empty}\ignorespaces
 	    \parbox[t]{\longindentation}{\raggedright\footnotesize\ignorespaces\fromaddress%
 	     }\fi\ignorespaces
     \parbox[t]{\indentedwidth}{\raggedright
	    \letterdate@ \\*[4ex]  
 	     \toname \\ \toaddress 
 	    }
     \par\vskip -1cm plus 1cm minus 2.2cm%
     \premat#1\par\nobreak%
     }
 }

\renewcommand{\closing}[1]{\par\nobreak\vspace{\parskip}%
  \stopbreaks
  \noindent
  %\ifx\@empty\fromaddress\else
  \hspace*{\longindentation}%
  %\fi
  \parbox{\indentedwidth}{\raggedright
   	   %\ignorespaces #1 \\ \scansign \\[-2ex]% in letterfr
       \ignorespaces #1\\ \scansign \\[-2\medskipamount]%
       \ifx\@empty\fromsig
           \fromname
       \else \fromsig \fi\strut}%
   \par\vskip 1cm minus 1cm}

%%%%%%%%%%%%%%%%%%%%%%%%%%

\newcommand\ps@metrifirstpage{%
     \let\@oddhead\@empty
     \def\@oddfoot{\raisebox{-25\p@}[\z@]{%
        \hb@xt@\textwidth{%\hspace*{100\p@}%
        \centerline{\Fmetri\fromlocation}}\hss}}}

\renewcommand*{\stopletter}{\vfill} %{}

\renewenvironment{letter}[1]
  {\newpage\unskip\hbox{}\unskip\kern-\topskip%x
    \if@twoside \ifodd\c@page
                \else\thispagestyle{empty}\null\newpage\fi
    \fi
    \c@page\@ne
    \interlinepenalty=200 % smaller than the TeXbook value
    \@processto{\leavevmode\ignorespaces #1}}
  {\stopletter%\@@par\pagebreak\@@par%
    \if@filesw
      \begingroup
        \let\\=\relax
        \let\protect\@unexpandable@protect
        \immediate\write\@auxout{%
          \string\@mlabel{\returnaddress}{\toname\\\toaddress}}%
      \endgroup%
    \fi}


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Customizing page sizes

 \textwidth=15.5cm
 \textheight=23.7cm 
 %\longindentation=8cm
 \newcommand\letterwidth[1]{  
	 \longindentation=.5\textwidth
	 \indentedwidth=\textwidth
	 \advance\indentedwidth -\longindentation}
 \newlength\metripageheight


%\setlength\headheight{12\p@}
\setlength\headsep   {20\p@}%{45\p@}
%\setlength\footskip{25\p@}
%\setlength\marginparsep {11\p@}
%\setlength\marginparpush{5\p@}
\setlength\topmargin{-30pt}%{27pt}
%\setlength\footnotesep{12\p@}
\if@compatibility
  \setlength\oddsidemargin{53pt}
  \setlength\evensidemargin{53pt}
  \setlength\marginparwidth{90pt}
\else
  \setlength\@tempdima{\paperwidth}
  \addtolength\@tempdima{-1.5in}   %{-2in}
  \addtolength\@tempdima{-\textwidth}
  \setlength\oddsidemargin   {.5\@tempdima}
  \setlength\evensidemargin  {\oddsidemargin}
  \setlength\marginparwidth  {90\p@}
\fi

 \clubpenalty=3000
 \widowpenalty=4000

%%%%%%%%%% end lettgr.sty %%%%%%%%%%%%%
